open Printf

exception Usage of string

(*take the input and the output file name
if output filename is not given by default, make it a.out*)
let _=

let (input_file,output_file) =
	if Array.length Sys.argv ==2 then
		let output_file_fname=Sys.argv.(1) in
			let output_file_index=String.index output_file_fname '.' in
				(Sys.argv.(1),(String.sub output_file_fname 0 output_file_index)^".out")

	else if Array.length Sys.argv ==4 then
		(Sys.argv.(1),Sys.argv.(3))

(*if wrong number of inputs are given raise an exception*)
	else
		raise(Usage("usage: ./nwql [input file name] or ./nwql <input file name> -o <output file name>"))
(*get the length of the input filename*)
in

	let input_file_length=String.length input_file in
		(*if a substring created from the position of 5th last character, with a length of 5 does not contain the correct file extension*)
		if (String.sub input_file (input_file_length -5) 5) <> ".nwql" then
			raise(Usage("usage: Input file should have an extension .nwql"))

		else

			let lexbuf = Lexing.from_channel (open_in input_file) in

				let program = Parser.program Scanner.token lexbuf in

					let python_program  = Translate.translate_program program in
						
						let pyFile = open_out output_file in

							fprintf pyFile "%s\n"  (Compile.string_of_program  python_program);

							close_out pyFile;

							Sys.command ("chmod +x " ^ output_file) ;

